﻿Type=StaticCode
Version=1.30
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	'
	Dim aval As Double, fval As Double
	Dim aval_t As Double, fval_t As Double
	Dim latitude As Double, longitude As Double
	Dim easting As Double, northing As Double
	Dim datum_easting As Double, datum_northing As Double
	Dim wgs84_easting As Double, wgs84_northing As Double
	Dim fixed_utm As Int, utmzone As String
	Dim elipelev As Double, error_msg As String
	Dim ecX As Double, ecY As Double, ecZ As Double
	Dim ecXout As Double, ecYout As Double, ecZout As Double
	Dim trans(8) As Double, local_datum As String
	Dim using_datum As String
	'
End Sub
Sub latlong_utm
	'
	'   converts lat and long to WGS84 easting/northing
	'
	Dim bval As Double, recf As Double
	Dim esquared As Double, e2squared As Double
	Dim tn As Double, ap As Double, bp As Double, cp As Double
	Dim dp As Double, ep As Double
	Dim olam As Double, dlam As Double, sval As Double, cval As Double, tval As Double
	Dim eta As Double, sn As Double, tmd As Double, t1 As Double, t2 As Double
	Dim t3 As Double, t6 As Double, t7 As Double, nfn As Double
	Dim latrad As Double, lonrad As Double
	'
	Dim utmxzone As Int, utmyzone As String
	Dim czones As String
	Dim sinsphi As Double, feval As Double, okval As Double
	'
	Dim i As Int
	'
	latrad = latitude * cPI / 180.0
	lonrad = longitude * cPI / 180.0
	czones = "CDEFGHJKLMNPQRSTUVWX"
	feval = 500000.0
	okval = 0.9996
	'        '
	If (fixed_utm = 0) Then
		utmxzone = (longitude / 6.0) 
		utmxzone=utmxzone+31
	Else
		utmxzone = fixed_utm
	End If
	'        
	i = (latitude + 80.0) / 8.0
	'		
	utmyzone = czones.substring2(i,i+1)
	utmzone = utmxzone & utmyzone
	'
	recf = 1.0 / fval
	bval = aval * (recf - 1.0) / recf
	'
	esquared = ((aval * aval) - (bval * bval)) / (aval * aval)
	e2squared = ((aval * aval) - (bval * bval)) / (bval * bval)
	'
	tn = (aval - bval) / (aval + bval)
	ap = 1.0 - tn + 5.0 * ((tn * tn) - (tn * tn * tn)) / 4.0
	ap = ap + 81.0 * ((tn * tn * tn * tn) - (tn * tn * tn * tn * tn)) / 64.0
	ap = aval * ap
	'
	bp = tn - (tn * tn) + 7.0 * ((tn * tn * tn) - (tn * tn * tn * tn)) / 8.0 + 55.0 * (tn * tn * tn * tn * tn) / 64.0
	bp = 3.0 * aval * bp / 2.0
	'
		cp = (tn * tn) - (tn * tn * tn) + 3.0 * ((tn * tn * tn * tn) - (tn * tn * tn * tn * tn)) / 4.0
	cp = 15.0 * aval * cp / 16.0
	'
		dp = (tn * tn * tn) - (tn * tn * tn * tn) + 11.0 * (tn * tn * tn * tn * tn) / 16.0
	dp = 35.0 * aval * dp / 48.0
	'
	ep = 315.0 * aval * ((tn * tn * tn * tn) - (tn * tn * tn * tn * tn)) / 512.0
	'
	olam = (utmxzone * 6.0 - 183.0) * cPI / 180.0
	dlam = lonrad - olam
	sval = Sin(latrad)
	cval = Cos(latrad)
	tval = sval / cval
	'
	eta = e2squared * (cval * cval)
	sinsphi = Sin(latrad)
	sn = aval / Sqrt(1.0 - esquared * (sinsphi * sinsphi))
	'
	tmd = (ap * latrad) - (bp * Sin(2.0 * latrad)) + (cp * Sin(4.0 * latrad)) - (dp * Sin(6.0 * latrad)) + (ep * Sin(8.0 * latrad))
	t1 = tmd * okval
	'
	t2 = sn * sval * cval * okval / 2.0
	'
		t6=(5.0 - (tval * tval) + 9.0 * eta + 4.0 * (eta * eta))
	t3 = sn * sval * (cval * cval * cval) * okval * t6 / 24.0
	'
	If (latrad < 0.0) Then
		nfn = 10000000.0
	Else
		nfn = 0.0
	End If
	'
	northing = nfn + t1 + (dlam * dlam) * t2 + (dlam * dlam * dlam * dlam) * t3 + (dlam * dlam * dlam * dlam * dlam * dlam) '+ 0.5
	'
	t6 = sn * cval * okval
	t7 = sn * (cval * cval * cval) * (1.0 - (tval * tval) + eta) / 6.0
	'
	easting = feval + dlam * t6 + (dlam * dlam * dlam) * t7 '+ 0.5
'
End Sub
Sub geod_earthcen
   '
   '   converts a lat/long/elipsoid height to earth centred coodinates
   '
   Dim recf As Double, nval As Double
   Dim esquared As Double
   Dim latrad As Double, lonrad As Double
   '
   latrad = latitude * cPI / 180.0
   lonrad = longitude * cPI / 180.0
   recf = 1.0 / fval
   esquared = 2.0* fval - fval * fval
   '
   nval = aval / Sqrt(1.0 - esquared * Sin(latrad) * Sin(latrad)) 
   '
   ecX = (nval + elipelev) * Cos(latrad) * Cos(lonrad)
   ecY = (nval + elipelev) * Cos(latrad) * Sin(lonrad)
   ecZ = ((1.0 - esquared) * nval + elipelev) * Sin(latrad)
'
    End Sub
Sub ectransform
   '
   '   performs a 7 parameter transformation on earth centred coordinates
   '
   Dim dx As Double, dy As Double, dz As Double
   Dim rx As Double, ry As Double, rz As Double, sc As Double
   '
   Dim rxrad As Double, ryrad As Double, rzrad As Double
   Dim xtemp As Double, ytemp As Double, ztemp As Double
   '
   dx = trans(1)
   dy = trans(2)
   dz = trans(3)
   rx = trans(4)
   ry = trans(5)
   rz = trans(6)
   sc = 1.0 + (trans(7) * 0.000001)
   '
   rxrad = (rx / 3600.0) * cPI / 180.0
   ryrad = (ry / 3600.0) * cPI / 180.0
   rzrad = (rz / 3600.0) * cPI / 180.0
   '
   xtemp = (Cos(ryrad) * Cos(rzrad)) * ecX + (Cos(ryrad) * Sin(rzrad)) * ecY - (Sin(ryrad)) * ecZ
   ytemp = (Sin(rxrad) * Sin(ryrad) * Cos(rzrad) - Cos(rxrad) * Sin(ryrad)) * ecX + (Sin(rxrad) * Sin(ryrad) * Sin(rzrad) + Cos(rxrad) * Cos(ryrad)) * ecY + (Sin(rxrad) * Cos(ryrad)) * ecZ
   ztemp = (Cos(rxrad) * Sin(ryrad) * Cos(rzrad) + Sin(rxrad) * Sin(rzrad)) * ecX + (Cos(rxrad) * Sin(ryrad) * Sin(rzrad) - Sin(rxrad) * Cos(rzrad)) * ecY + (Cos(rxrad) * Cos(ryrad)) * ecZ
   '
   xtemp = xtemp * sc
   ytemp = ytemp * sc
   ztemp = ztemp * sc
   '
   ecXout = xtemp + dx
   ecYout = ytemp + dy
   ecZout = ztemp + dz
   '
End Sub
Sub geodtransform
	'
	'   converts earth centred coordinates to lat/long/height on a particular datum
	'
	Dim recf As Double
	Dim esquared As Double
	Dim pval As Double, rval As Double, tempval As Double
	Dim lattopline As Double, latbotline As Double, uval As Double
	'
	recf = 1.0 / fval
	esquared = 2.0 * fval - fval * fval
	'
	pval = Sqrt(ecX * ecX + ecY * ecY)
	rval = Sqrt(pval * pval + ecZ * ecZ)
	tempval = (1.0 - fval) + (esquared * aval) / rval
	tempval = tempval * ecZ / pval
	uval = ATan(tempval)
	'
	lattopline = ecZ * (1.0 - fval) + esquared * aval * Sin(uval) * Sin(uval) * Sin(uval)
	latbotline = (1.0 - fval) * (pval - esquared * aval * Cos(uval) * Cos(uval) * Cos(uval))
	longitude = ATan(ecY / ecX)
	If (longitude < 0.0) Then longitude = longitude + cPI
	'
	latitude = ATan(lattopline / latbotline)
	'
	elipelev = pval * Cos(latitude) + ecZ * Sin(latitude) - aval * Sqrt(1.0 - esquared * Sin(latitude) * Sin(latitude))
	latitude = latitude * 180.0 / cPI
	longitude = longitude * 180.0 / cPI
	'
End Sub
Sub convert_to_local_datum
	'
	'   converts lats/longs to local datum
	'
	If (local_datum = "THAILAND") Then
		trans(1) = -203.88
		trans(2) = -832.9
		trans(3) = -293.96
		trans(4) = 0.0038
		trans(5) = -0.0579
		trans(6) = -0.0781
		trans(7) = 0.017
		aval_t = 6377276.345
		fval_t = 1.0 / 300.8017
		using_datum=local_datum
	Else
		trans(1) = 0.0
		trans(2) = 0.0
		trans(3) = 0.0
		trans(4) = 0.0
		trans(5) = 0.0
		trans(6) = 0.0
		trans(7) = 0.0	
		aval_t = 6378137.0
		fval_t = 1.0 / 298.257223563
		using_datum="None"
	End If
	'
	aval = 6378137.0
	fval = 1.0 / 298.257223563
	elipelev = 195.0
	'
	latlong_utm
	wgs84_easting=Round2(easting,2)
	wgs84_northing=Round2(northing,2)
	'
	geod_earthcen
	'
	ectransform
	'
	aval = aval_t
	fval = fval_t
	ecX=ecXout
	ecY=ecYout
	ecZ=ecZout
	'
	geodtransform
	'
	latlong_utm
	datum_easting=Round2(easting,2)
	datum_northing=Round2(northing,2)
	'
End Sub

	
 
 
