﻿Type=StaticCode
Version=1.30
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	'
	Dim gps_string As String
	Dim current_string As String
	Dim myfields() As String
	Dim got_an_error As Boolean
	Dim error_msg As String
	'
    '   GGA variables
    '
    Dim UTC_time As String
    Dim latitude As Double
    Dim lat_type As String
    Dim longitude As Double
    Dim long_type As String
    Dim quality As String
    Dim height_MSL As Double
    Dim geoidal_sepn As Double
    Dim height_units As String
    Dim age As Int
    Dim ref_stn As String
	'
    '   GSA variables
    '
    Dim mode As String
    Dim current_mode As String
    Dim sat_prn(12) As Int
    Dim num_sat_prn As Int
    Dim pdop As Double
    Dim hdop As Double
    Dim vdop As Double
	'
    '   GST variables
    '
    Dim lat_error As Double
    Dim long_error As Double
    Dim horz_error As Double
    Dim height_error As Double

End Sub
Sub check_GPS(myval As Boolean)
'
	current_string = "None"
	If (gps_string.SubString2(0,6) = "$GPGGA") Then
		current_string = "GGA"
		parse_GGA
	End If
	If (gps_string.SubString2(0,6) = "$GPGSA") Then
		current_string = "GSA"
		parse_GSA
	End If
	If (gps_string.SubString2(0,6) = "$GPGST") Then
		current_string = "GST"
		parse_GST
	End If
End Sub

Sub parse_GGA
	'
	'	parses a GGA string
	'
	Dim myval1 As Double, myval2 As Double, mystr As String
    myfields = Regex.Split(",",gps_string)
	If(myfields.Length < 14) Then 
	   Return
	End If
    '
    '  check if we actually have data
    '
    quality = "No GPS"
    got_an_error = False
	error_msg="no error"
    '
	Try
		UTC_time=myfields(1).SubString2(0,2) & ":" & myfields(1).SubString2(2,4) & ":" & myfields(1).SubString2(4,6)
		myval1=myfields(2).SubString2(0,2)
		myval2=myfields(2).SubString(2)
		myval2=myval2/60.0
		latitude=Round2(myval1+myval2,7)
		lat_type=myfields(3)
		'
		myval1=myfields(4).SubString2(0,3)
		myval2=myfields(4).SubString(3)
		myval2=myval2/60.0
		longitude=Round2(myval1+myval2,7)
		long_type=myfields(5)
		'
		quality=""
		If(myfields(6)="0") Then
			quality="No GPS"
		End If
		If(myfields(6)="1") Then
			quality="GPS"
		End If
		If(myfields(6)="2") Then
			quality="DGPS"
		End If
		If(myfields(6)="4") Then
			quality="HP Fixed"
		End If
		If(myfields(6)="5") Then
			quality="HP Float"
		End If
		'
		height_MSL=myfields(9)
		height_units=myfields(10)
		geoidal_sepn=myfields(11)
		'
		If(myfields(13) <> "") Then
			age=myfields(13)
		Else
			age=0	
		End If
		'
		ref_stn="??"
		If(myfields(14) <> "") Then
			If(myfields(14).substring2(0,4) = "0100") Then
				ref_stn = "VBS"
			End If
			If(myfields(14).substring2(0,4) = "1000") Then
				ref_stn = "HP"
			End If
			If(myfields(14).substring2(0,4) = "1008") Then
				ref_stn = "XP"
			End If
			If(myfields(14).substring2(0,4) = "1016") Then
				ref_stn = "HP & XP"
			End If
		End If
	Catch
	    error_msg=LastException.Message
		'
	End Try
'
End Sub
Sub parse_GSA
	'
	'	parses a GSA string
	'
	Dim isat As Int
	myfields = Regex.Split(",",gps_string)
	If(myfields.length < 17) Then 
	   Return
	End If 
'
	Try
	'
		mode=myfields(1)
		If(mode="M") Then
			mode="Manual"
		Else
			mode="Automatic"
		End If
		If(myfields(2)="1") Then
			current_mode="No fix"
		Else If (myfields(2)="2") Then
			current_mode="2D fix"
		Else If (myfields(2)="3") Then
			current_mode="3D fix"
		End If
		'
		num_sat_prn=0
		For isat=1 To 12
			sat_prn(isat-1)=0
			If(myfields(isat+2)<>"") Then
				num_sat_prn=num_sat_prn+1
				
				sat_prn(isat-1)=myfields(isat+2)
			End If
		Next
		'
		pdop=0.0
		hdop=0.0
		vdop=0.0
		'
		If(myfields(15)<>"") Then
			pdop=myfields(15)
		End If
		If(myfields(16)<>"") Then
			hdop=myfields(16)
		End If
		If(myfields(17)<>"") Then
			vdop=myfields(17)
		End If
		'
	Catch
	End Try

End Sub
Sub parse_GST
       ' 
   myfields = Regex.Split(",",gps_string)
	If(myfields.Length < 8) Then 
	   Return
	End If
	'
	Try
   '
		If (myfields(6) <> "") Then
			lat_error = myfields(6) 
			lat_error=100.0*lat_error
			lat_error = Round2(lat_error,1)
		Else
			lat_error = 0
		End If
		If (myfields(7) <> "") Then
			long_error = myfields(7) 
			long_error=100.0*long_error
			long_error = Round2(long_error,1)
		Else
			long_error = 0
		End If
		If (myfields(8) <> "") Then
			height_error = myfields(8) 
			height_error=100.0*height_error
			height_error = Round2(height_error,1)
		Else
			height_error = 0
		End If
		'
		'   calc horizontal error
		'
		horz_error = Sqrt((lat_error * lat_error) + (long_error * long_error))
		horz_error = Round2(horz_error, 1)
		'
	Catch
	End Try
End Sub



