﻿Type=StaticCode
Version=1.30
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
'
	Dim filename As String
	Dim linename As String
	Dim antenna_hgt As Double
	Dim fixed_UTM As Int
	Dim datum As String
	Dim peg_step As Int
	Dim peg_interval As Double
	Dim time_zone As Int
	Dim simulation As Boolean
	Dim myset As Map, mylist(10) As List
	'
End Sub
Sub create_file
	'
	'	create settings file
	'
	If(File.IsDirectory(File.DirRootExternal,"GPS_nmea") = False) Then
		File.MakeDir(File.DirRootExternal,"GPS_nmea")
	End If
	'
	myset.Initialize
	myset.Put("filename","TEST")
	myset.Put("linename","LN-01")
	myset.Put("antenna_hgt","2.0")
	myset.Put("fixed_UTM","48")
	myset.Put("datum","THAILAND")
	myset.Put("peg_step","2")
	myset.Put("peg_interval","10.0")
	myset.Put("time_zone","7")
	myset.Put("simulation",False)
	'
	File.WriteMap(File.DirRootExternal & "/GPS_nmea","prog-settings.txt",myset)
	'
End Sub
Sub load_file
	'
	'	load the user settings
	'
	If(myset.IsInitialized=False) Then
		myset.Initialize
	End If
	'
	If(File.exists(File.DirRootExternal & "/GPS_nmea","prog-settings.txt")=False) Then
		create_file
	End If
	myset=File.ReadMap2(File.DirRootExternal & "/GPS_nmea","prog-settings.txt",myset)
	filename=myset.Get("filename")
	filename=filename.ToUpperCase
	linename=myset.get("linename")
	linename=linename.ToUpperCase
	antenna_hgt=myset.get("antenna_hgt")
	fixed_UTM=myset.get("fixed_UTM")
	datum=myset.Get("datum")
	datum=datum.ToUpperCase
	peg_step=myset.get("peg_step")
	peg_interval=myset.get("peg_interval")
	time_zone=myset.Get("time_zone")
	simulation=myset.Get("simulation")
	'
End Sub
Sub save_file
	'
	'	save the user settings
	'
	myset.Initialize
	filename=filename.ToUpperCase
	myset.Put("filename",filename)
	linename=linename.ToUpperCase
	myset.Put("linename",linename)
	myset.Put("antenna_hgt",antenna_hgt)
	myset.Put("fixed_UTM",fixed_utm)
	datum=datum.ToUpperCase
	myset.Put("datum",datum)
	myset.Put("peg_step",peg_step)
	myset.Put("peg_interval",peg_interval)
	myset.Put("time_zone",time_zone)
	myset.Put("simulation",simulation)
	'
	File.WriteMap(File.DirRootExternal & "/GPS_nmea","prog-settings.txt",myset)
	'
End Sub



